package umfpack;

import java.util.*;

public class Umfpack {
	// native methods
    public native int  factorize(int n, int[] Ap, int[] Ai, double[] Ax);
    public native void solve(int id, double[] b, double[] x);
    public native void release(int id);
		
    static {
        System.loadLibrary("umfpack");
    }





	

	// interface calls (compatibility with taucs)
	public void InitTaucsInterface(){}
	public void DeinitTaucsInterface(){}
	public int CreateMatrix(int numRows, int numCols){
		// find open slot
		int id = -1;
		for(int i=0; i<packets.length; i++){
			if (packets[i] == null)
				id = i;
		}
		packets[id] = new Packet();
		packets[id].A = new SparseMatrix(numRows, numCols);
		return id;
	}
	public void ReleaseMatrix(int id){
		if (packets[id].umfpack_id != -1)
			release(packets[id].umfpack_id);
		packets[id] = null;
	}
	
	public void SetMatrixEntry(int id, int i, int j, double v){
		packets[id].A.add(i, j, v);
	}
	public boolean FactorATA(int id){
		packets[id].AT = SparseMatrix.transpose(packets[id].A);
		packets[id].ATA = SparseMatrix.tranpose_and_multiply(packets[id].A);
		packets[id].umfpack_id = SparseMatrix.factorize(this, packets[id].ATA);		
		return true;
	}
	public boolean SolveATA(int id, double[] b, double[] x){
		solve(packets[id].umfpack_id, SparseMatrix.multiply(packets[id].AT, b), x);
		return true;
	}
	
	
	
	private Packet[] packets = new Packet[100];
	
	
	class Packet {
		int umfpack_id = -1;
		SparseMatrix A;
		SparseMatrix AT;
		SparseMatrix ATA;
	}
}
